package mfsm.jssp;

import org.junit.Assert;
import org.junit.Test;

/** A Test for the JSSP Instance */
public class TestJSSP {

  /** test the demo instance */
  @SuppressWarnings("static-method")
  @Test(timeout = 3600000)
  public void test_load_demo() {
    final Problem inst = new Problem("demo"); //$NON-NLS-1$
    Assert.assertEquals(4, inst.jobs);
    Assert.assertEquals(5, inst.machines);
  }

  /** test the abz5 instance */
  @SuppressWarnings("static-method")
  @Test(timeout = 3600000)
  public void test_load_abz5() {
    final Problem inst = new Problem("abz5"); //$NON-NLS-1$
    Assert.assertEquals(10, inst.jobs);
    Assert.assertEquals(10, inst.machines);

    Assert.assertEquals(4, inst.job_machine_times[0][0]);
    Assert.assertEquals(88, inst.job_machine_times[0][1]);
    Assert.assertEquals(8, inst.job_machine_times[0][2]);
    Assert.assertEquals(68, inst.job_machine_times[0][3]);
    Assert.assertEquals(6, inst.job_machine_times[0][4]);
    Assert.assertEquals(94, inst.job_machine_times[0][5]);
    Assert.assertEquals(0, inst.job_machine_times[0][16]);
    Assert.assertEquals(86, inst.job_machine_times[0][17]);
    Assert.assertEquals(3, inst.job_machine_times[0][18]);
    Assert.assertEquals(92, inst.job_machine_times[0][19]);

    Assert.assertEquals(5, inst.job_machine_times[1][0]);
    Assert.assertEquals(72, inst.job_machine_times[1][1]);
    Assert.assertEquals(3, inst.job_machine_times[1][2]);
    Assert.assertEquals(50, inst.job_machine_times[1][3]);
    Assert.assertEquals(6, inst.job_machine_times[1][4]);
    Assert.assertEquals(69, inst.job_machine_times[1][5]);
    Assert.assertEquals(7, inst.job_machine_times[1][16]);
    Assert.assertEquals(94, inst.job_machine_times[1][17]);
    Assert.assertEquals(9, inst.job_machine_times[1][18]);
    Assert.assertEquals(63, inst.job_machine_times[1][19]);

    Assert.assertEquals(3, inst.job_machine_times[9][0]);
    Assert.assertEquals(50, inst.job_machine_times[9][1]);
    Assert.assertEquals(0, inst.job_machine_times[9][2]);
    Assert.assertEquals(59, inst.job_machine_times[9][3]);
    Assert.assertEquals(1, inst.job_machine_times[9][4]);
    Assert.assertEquals(82, inst.job_machine_times[9][5]);
    Assert.assertEquals(5, inst.job_machine_times[9][16]);
    Assert.assertEquals(59, inst.job_machine_times[9][17]);
    Assert.assertEquals(2, inst.job_machine_times[9][18]);
    Assert.assertEquals(96, inst.job_machine_times[9][19]);
  }
}